<?php

declare(strict_types=1);

namespace Drupal\Tests\config_ignore_readonly\Functional;

use Drupal\Tests\config_readonly\Functional\ReadOnlyConfigTest;

/**
 * Test description.
 *
 * @group config_ignore_readonly
 */
class ConfigIgnoreReadonlyTest extends ReadOnlyConfigTest {


  /**
   * {@inheritdoc}
   */
  protected static $modules = [
    'config_ignore_readonly',
    'config_ignore',
    'config_filter',
    'config_readonly',
  ];

  /**
   * {@inheritdoc}
   */
  protected $defaultTheme = 'stark';

  /**
   * {@inheritdoc}
   */
  public function setUp(): void {
    parent::setUp();

    // Set up test config.
    $config = $this->config('config_ignore.settings');
    $config->set('ignored_config_entities', [
      'automated_cron.settings',
      'system.cron',
    ]);
    $config->save();
  }

  /**
   * Test callback.
   */
  public function testWhitelistHook(): void {
    $this->turnOnReadOnlySetting();
    $assert_session = $this->assertSession();
    $this->drupalGet('admin/config/system/cron');
    // Warning not shown on cron config page.
    $assert_session->pageTextNotContains('This form will not be saved because the configuration active store is read-only.');
  }

}
